local drawableSprite = require("structs.drawable_sprite")
local utils = require("utils")

local danglefruit = {}

danglefruit.name = "RainKit/Danglefruit"
danglefruit.depth = 2000
danglefruit.canResize = {false, true}
danglefruit.placements = {
    name = "Dangle Fruit",
    data = {
        height = 16,
        color = "ffffff",
        respawnTime = 2
    }
}

function danglefruit.sprite(room, entity)
    local sprites = {}
    local height = math.max(entity.height or 0, 16)

    local topSprite = drawableSprite.fromTexture("objects/RainKit/danglefruit", entity)

    topSprite:setJustification(0, 0)
    topSprite:setOffset(0, 0)
    topSprite:useRelativeQuad(0, 0, 8, 8)

    table.insert(sprites, topSprite)

    for i = 0, height - 16, 8 do
        local middleSprite = drawableSprite.fromTexture("objects/RainKit/danglefruit", entity)

        middleSprite:setJustification(0, 0)
        middleSprite:setOffset(0, 0)
        middleSprite:addPosition(0, i)
        middleSprite:useRelativeQuad(0, 8, 8, 8)

        table.insert(sprites, middleSprite)
    end

    local bottomSprite = drawableSprite.fromTexture("objects/RainKit/danglefruit", entity)

    bottomSprite:setJustification(0, 0)
    bottomSprite:setOffset(0, 0)
    bottomSprite:addPosition(0, height - 8)
    bottomSprite:useRelativeQuad(0, 24, 8, 8)

    table.insert(sprites, bottomSprite)

    return sprites
end

function danglefruit.selection(room, entity)
    return utils.rectangle(entity.x, entity.y, 8, math.max(entity.height, 16))
end

return danglefruit